Package org.jboss.resteasy.core.providerfactory

## Class ServerHelper

- java.lang.Object
- - org.jboss.resteasy.core.providerfactory.CommonProviders
  - - org.jboss.resteasy.core.providerfactory.ServerHelper

- Direct Known Subclasses:
    `NOOPServerHelper`

      public class ServerHelper
      extends CommonProviders

- - ### Field Summary

    Fields
    Modifier and Type | Field | Description
    --- | --- | ---
    `protected Map<Class<?>,​AsyncResponseProvider>` | `asyncResponseProviders` |
    `protected Map<Class<?>,​AsyncStreamProvider>` | `asyncStreamProviders` |
    `protected boolean` | `attachedAsyncResponseProviders` |
    `protected boolean` | `attachedAsyncStreamProviders` |
    `protected boolean` | `attachedExceptionMappers` |
    `protected boolean` | `attachedRequestFilters` |
    `protected boolean` | `attachedResponseFilters` |
    `protected Map<Class<?>,​SortedKey<javax.ws.rs.ext.ExceptionMapper>>` | `exceptionMappers` |
    `protected JaxrsInterceptorRegistry<javax.ws.rs.container.ContainerRequestFilter>` | `requestFilters` |
    `protected JaxrsInterceptorRegistry<javax.ws.rs.container.ContainerResponseFilter>` | `responseFilters` |

    - ### Fields inherited from class org.jboss.resteasy.core.providerfactory.CommonProviders

      `attachedFeatures, attachedMessageBodyReaders, attachedMessageBodyWriters, attachedReaderInterceptors, attachedWriterInterceptors, dynamicFeatures, lockSnapshots, messageBodyReaders, messageBodyWriters, readerInterceptorRegistry, rpf, writerInterceptorRegistry`

  - ### Constructor Summary

    Constructors
    Constructor | Description
    --- | ---
    `ServerHelper()` |
    `ServerHelper​(ResteasyProviderFactoryImpl rpf)` |
    `ServerHelper​(ResteasyProviderFactoryImpl rpf, ServerHelper parent)` |

  - ### Method Summary

    All Methods Instance Methods Concrete Methods
    Modifier and Type | Method | Description
    --- | --- | ---
    `void` | `addAsyncResponseProvider​(Class provider)` |
    `void` | `addAsyncStreamProvider​(Class provider)` |
    `void` | `addContainerRequestFilter​(Class provider, int priority)` |
    `void` | `addContainerResponseFilter​(Class provider, int priority)` |
    `void` | `addExceptionMapper​(Class provider, boolean isBuiltin)` |
    `Map<Class<?>,​AsyncResponseProvider>` | `getAsyncResponseProviders()` |
    `protected Map<Class<?>,​AsyncResponseProvider>` | `getAsyncResponseProvidersForWrite()` |
    `Map<Class<?>,​AsyncStreamProvider>` | `getAsyncStreamProviders()` |
    `protected Map<Class<?>,​AsyncStreamProvider>` | `getAsyncStreamProvidersForWrite()` |
    `Map<Class<?>,​SortedKey<javax.ws.rs.ext.ExceptionMapper>>` | `getExceptionMappers()` |
    `protected Map<Class<?>,​SortedKey<javax.ws.rs.ext.ExceptionMapper>>` | `getExceptionMappersForWrite()` |
    `protected MediaTypeMap<SortedKey<javax.ws.rs.ext.MessageBodyReader>>` | `getMessageBodyReadersForWrite()` |
    `protected MediaTypeMap<SortedKey<javax.ws.rs.ext.MessageBodyWriter>>` | `getMessageBodyWritersForWrite()` |
    `protected JaxrsInterceptorRegistry<javax.ws.rs.ext.ReaderInterceptor>` | `getReaderInterceptorRegistryForWrite()` |
    `JaxrsInterceptorRegistry<javax.ws.rs.container.ContainerRequestFilter>` | `getRequestFilters()` |
    `protected JaxrsInterceptorRegistry<javax.ws.rs.container.ContainerRequestFilter>` | `getRequestFiltersForWrite()` |
    `JaxrsInterceptorRegistry<javax.ws.rs.container.ContainerResponseFilter>` | `getResponseFilters()` |
    `protected JaxrsInterceptorRegistry<javax.ws.rs.container.ContainerResponseFilter>` | `getResponseFiltersForWrite()` |
    `protected JaxrsInterceptorRegistry<javax.ws.rs.ext.WriterInterceptor>` | `getWriterInterceptorRegistryForWrite()` |
    `protected void` | `processProviderContracts​(Class provider, Integer priorityOverride, boolean isBuiltin, Map<Class<?>,​Integer> contracts, Map<Class<?>,​Integer> newContracts)` |
    `protected void` | `processProviderInstanceContracts​(Object provider, Map<Class<?>,​Integer> contracts, Integer priorityOverride, boolean builtIn, Map<Class<?>,​Integer> newContracts)` |

    - ### Methods inherited from class org.jboss.resteasy.core.providerfactory.CommonProviders

      `addCompositeWildcardMBR, addCompositeWildcardMBW, addDynamicFeature, addMessageBodyReader, addMessageBodyWriter, addReaderInterceptor, addRegularMBR, addRegularMBW, addSubtypeWildMBR, addSubtypeWildMBW, addWildcardCompositeMBR, addWildcardCompositeMBW, addWildcardMBR, addWildcardMBW, addWriterInterceptor, getDynamicFeatures, getDynamicFeaturesForWrite, getMessageBodyReaders, getMessageBodyWriters, getReaderInterceptorRegistry, getWriterInterceptorRegistry, lockSnapshots`

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

- - ### Field Detail

    - #### attachedRequestFilters

          protected boolean attachedRequestFilters

    - #### requestFilters

          protected JaxrsInterceptorRegistry<javax.ws.rs.container.ContainerRequestFilter> requestFilters

    - #### attachedResponseFilters

          protected boolean attachedResponseFilters

    - #### responseFilters

          protected JaxrsInterceptorRegistry<javax.ws.rs.container.ContainerResponseFilter> responseFilters

    - #### attachedAsyncResponseProviders

          protected boolean attachedAsyncResponseProviders

    - #### asyncResponseProviders

          protected Map<Class<?>,​AsyncResponseProvider> asyncResponseProviders

    - #### attachedAsyncStreamProviders

          protected boolean attachedAsyncStreamProviders

    - #### asyncStreamProviders

          protected Map<Class<?>,​AsyncStreamProvider> asyncStreamProviders

    - #### attachedExceptionMappers

          protected boolean attachedExceptionMappers

    - #### exceptionMappers

          protected Map<Class<?>,​SortedKey<javax.ws.rs.ext.ExceptionMapper>> exceptionMappers

  - ### Constructor Detail

    - #### ServerHelper

          public ServerHelper()

    - #### ServerHelper

          public ServerHelper​(ResteasyProviderFactoryImpl rpf)

    - #### ServerHelper

          public ServerHelper​(ResteasyProviderFactoryImpl rpf,
                              ServerHelper parent)

  - ### Method Detail

    - #### getReaderInterceptorRegistryForWrite

          protected JaxrsInterceptorRegistry<javax.ws.rs.ext.ReaderInterceptor> getReaderInterceptorRegistryForWrite()

      Overrides:
        `getReaderInterceptorRegistryForWrite` in class `CommonProviders`

    - #### getWriterInterceptorRegistryForWrite

          protected JaxrsInterceptorRegistry<javax.ws.rs.ext.WriterInterceptor> getWriterInterceptorRegistryForWrite()

      Overrides:
        `getWriterInterceptorRegistryForWrite` in class `CommonProviders`

    - #### getMessageBodyReadersForWrite

          protected MediaTypeMap<SortedKey<javax.ws.rs.ext.MessageBodyReader>> getMessageBodyReadersForWrite()

      Overrides:
        `getMessageBodyReadersForWrite` in class `CommonProviders`

    - #### getMessageBodyWritersForWrite

          protected MediaTypeMap<SortedKey<javax.ws.rs.ext.MessageBodyWriter>> getMessageBodyWritersForWrite()

      Overrides:
        `getMessageBodyWritersForWrite` in class `CommonProviders`

    - #### processProviderContracts

          protected void processProviderContracts​(Class provider,
                                                  Integer priorityOverride,
                                                  boolean isBuiltin,
                                                  Map<Class<?>,​Integer> contracts,
                                                  Map<Class<?>,​Integer> newContracts)

      Overrides:
        `processProviderContracts` in class `CommonProviders`

    - #### addExceptionMapper

          public void addExceptionMapper​(Class provider,
                                         boolean isBuiltin)

    - #### addAsyncStreamProvider

          public void addAsyncStreamProvider​(Class provider)

    - #### addAsyncResponseProvider

          public void addAsyncResponseProvider​(Class provider)

    - #### addContainerResponseFilter

          public void addContainerResponseFilter​(Class provider,
                                                 int priority)

    - #### addContainerRequestFilter

          public void addContainerRequestFilter​(Class provider,
                                                int priority)

    - #### processProviderInstanceContracts

          protected void processProviderInstanceContracts​(Object provider,
                                                          Map<Class<?>,​Integer> contracts,
                                                          Integer priorityOverride,
                                                          boolean builtIn,
                                                          Map<Class<?>,​Integer> newContracts)

      Overrides:
        `processProviderInstanceContracts` in class `CommonProviders`

    - #### getRequestFiltersForWrite

          protected JaxrsInterceptorRegistry<javax.ws.rs.container.ContainerRequestFilter> getRequestFiltersForWrite()

    - #### getResponseFiltersForWrite

          protected JaxrsInterceptorRegistry<javax.ws.rs.container.ContainerResponseFilter> getResponseFiltersForWrite()

    - #### getAsyncResponseProvidersForWrite

          protected Map<Class<?>,​AsyncResponseProvider> getAsyncResponseProvidersForWrite()

    - #### getAsyncStreamProvidersForWrite

          protected Map<Class<?>,​AsyncStreamProvider> getAsyncStreamProvidersForWrite()

    - #### getExceptionMappersForWrite

          protected Map<Class<?>,​SortedKey<javax.ws.rs.ext.ExceptionMapper>> getExceptionMappersForWrite()

    - #### getRequestFilters

          public JaxrsInterceptorRegistry<javax.ws.rs.container.ContainerRequestFilter> getRequestFilters()

    - #### getResponseFilters

          public JaxrsInterceptorRegistry<javax.ws.rs.container.ContainerResponseFilter> getResponseFilters()

    - #### getAsyncResponseProviders

          public Map<Class<?>,​AsyncResponseProvider> getAsyncResponseProviders()

    - #### getAsyncStreamProviders

          public Map<Class<?>,​AsyncStreamProvider> getAsyncStreamProviders()

    - #### getExceptionMappers

          public Map<Class<?>,​SortedKey<javax.ws.rs.ext.ExceptionMapper>> getExceptionMappers()